/*
 * eeprom.h
 *
 *  Created on: 25.01.2013
 *      Author: kalle
 */

#ifndef EEPROM_H_
#define EEPROM_H_

#include <avr/io.h>


#define Dev24C512 0xA0

// groesse in byte
#define EEPROM_SIZE 65536
//#define EEPROM_SIZE 0xFA00

#define DELAY 11


void eeprom_init();

void eeprom_write(uint16_t addr, uint8_t val);
void eeprom_write_inc(uint16_t* addr, uint8_t val);
uint8_t eeprom_read(uint16_t addr);
uint8_t eeprom_read_inc(uint16_t* addr);

void eeprom_write_twice(uint16_t addr, uint16_t val);
void eeprom_write_twice_inc(uint16_t* addr, uint16_t val);
uint16_t eeprom_read_twice(uint16_t addr);
uint16_t eeprom_read_twice_inc(uint16_t* addr);

uint16_t eeprom_inc_addr(uint32_t addr);



#endif /* EEPROM_H_ */
