/*
 * main.c
 *
 *  Created on: 25.01.2013
 *      Author: kalle
 */

#include "main.h"

#include <avr/io.h>
#include <avr/interrupt.h>	// sei

#include <util/delay.h>			// delay_ms

#include "i2cmaster.h"			// I2C interace
#include "uart.h"						// uart (RS232)
#include "eeprom.h"					// i2c eeprom


#define BAUDRATE 9600


int main()
{
	// initialisieren des I2C bus
	i2c_init();

	// initialisiere uart
	usart_init(BAUDRATE);

	sei();

	eeprom_init();


	_delay_ms(100);
	usart_write(CR CR "-- start --" CR);
	_delay_ms(100);


	uint16_t start = 0x0040;
	uint32_t ende = 0x10000;
	ende = 0x3000;

	//DDRA  &= ~(1<<PA0);  /* Pin PA0 als Eingang */

	for (uint32_t addr = start; addr < ende; addr++)
	{
		uint8_t val = eeprom_read((uint16_t)addr);

		if (val > 0)
			eeprom_write((uint16_t)addr, 0);
	}

	_delay_ms(20);

	for (uint16_t addr = start; addr < (start+0x12); addr++)
	{
		uint8_t val = eeprom_read(addr);
		if (val > 127)
		{
			printf("%x:%b" CR, addr, val);
		}
		else
		{
			printf("%x:%i" CR, addr, val);
		}
	}

	_delay_ms(20);

	i2c_start_wait(Dev24C512+I2C_WRITE);
	i2c_write((start / 256));
	i2c_write((start % 256));
	i2c_write(0b11000001);
	i2c_write(11 + 128);
	i2c_write(13);
	i2c_write(1);
	i2c_write(30);
	i2c_write(17);
	i2c_write(19);
	i2c_write(6);
	i2c_write(10);
	i2c_write(0b11000010);
	i2c_stop();

	uint16_t cur_addr = start + 10;

	_delay_ms(20);

	for (uint16_t addr = start; addr < (start+0x12); addr++)
	{
		uint8_t val = eeprom_read(addr);
		if (val > 127)
		{
			printf("%x:%b" CR, addr, val);
		}
		else
		{
			printf("%x:%i" CR, addr, val);
		}
	}

	_delay_ms(20);

	//for (uint16_t i = 0; i < 2046; i++)
	uint16_t i = 0;
	for (i = 0; i < 4096; i+=3)
	{
		//eeprom_write_twice_inc(&cur_addr, 97);
		eeprom_write(cur_addr+i, 97);

		/*uint8_t val = eeprom_read(start);
		if (val != 0b11000001)
		{
			printf("val %x:%b" CR, start, val);
			printf("break %i %x i%i" CR, (cur_addr-1), (cur_addr-1), i);
			_delay_ms(10);
			break;
		}*/
	}
	cur_addr+=i;

	_delay_ms(20);

	//eeprom_write_inc(&cur_addr, 0b11000100);
	//eeprom_write_inc(&cur_addr, 11 + 128);
	printf("ende %x" CR, cur_addr);

	uint8_t val = eeprom_read(start);
	printf("%x:%i" CR, cur_addr-1, val);

	printf(CR CR);

	for (uint16_t addr = start; addr < (start+0x12); addr++)
	{
		uint8_t val = eeprom_read(addr);
		if (val > 99)
		{
			printf("%x:%b" CR, addr, val);
		}
		else
		{
			printf("%x:%i" CR, addr, val);
		}
	}

	printf(CR CR);


	while(1);

	return 0;
}
